unit DebuggerUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ToolWin, ExtCtrls, Menus, IniFiles, TypInfo,
  ShellApi, Buttons, math, PageSheet, ELSuperEdit;

type
   TDebugger=class(TStringList)
   private
     fFiles:TStrings;
   public
     constructor create;
     destructor destroy; override;
     procedure AddFile(v:string);
     function FileDebugExists(v:string):integer;
     function isFileOpen(v:string):TPageSheet;
     procedure Scan;
     procedure Reset;
     property Files:TStrings read ffiles;
   end;

implementation

uses MainUnit;

{ TDebugger }
constructor TDebugger.create;
begin
   fFiles:=TStringList.Create;
end;

destructor TDebugger.destroy;
begin
   fFiles.Free;
   inherited;
end;

procedure TDebugger.AddFile(v:string);
begin
       if ffiles.IndexOf(v)=-1 then
          ffiles.Add(v);
end;

function TDebugger.FileDebugExists(v:string):integer;
var
   i:integer;
begin
    result:=-1;
    if v='' then exit;
    i:=IndexOf(v);
    result:=i;
end;

procedure TDebugger.Scan;
var
   i,fd,vl,e:integer;
   s,p,v,en:string;
   Ps:TPageSheet;
   err:TError;
label
   Skip;
   function Number(v:string):string;
   var
      i:integer;
   begin
      result:='';
      if v='' then exit;
      for i:=1 to length(v) do
          if v[i] in ['0'..'9'] then
             result:=result+v[i];
   end;
begin
   if Count=0 then exit;
   i:=0;
   repeat
         s:=trim(Self[i]);
         if s='' then goto skip;
         if Count>0 then begin
            p:=copy(s,1,pos('(',s)-1);
            v:=copy(s,pos('(',s)+1,pos(')',s)-pos('(',s)-1);
            if pos(' error ',lowercase(s))>0 then begin
               en:=trim(copy(s,pos(' error ',lowercase(s))+6,length(s)));
               en:=trim(copy(en,1,pos(':',en)-1));
            end ;
               if fileexists(p) then begin
                  ps:=isFileOpen(p);
                  if ps=nil then begin
                     ps:=Main.newPage(p);
                     fd:=FileDebugExists(p);
                     if fd>-1 then AddFile(p);
                     v:=number(v);
                     en:=number(en);
                     err:=TError.Create;
                     val(v,vl,e);
                     if e=0 then err.Line:=vl;
                     val(en,vl,e);
                     err.Number:=vl;
                     if ps.Frame<>nil then begin
                     ps.Frame.Edit.Errors.AddObject(v,err);
                     ps.Frame.Edit.Repaint;
                     end
                  end else begin
                     fd:=FileDebugExists(p);
                     if fd>-1 then AddFile(p);
                     v:=number(v);
                     en:=number(en);
                     err:=TError.Create;
                     val(v,vl,e);
                     if e=0 then err.Line:=vl;
                     val(en,vl,e);
                     err.Number:=vl;
                     ps.Frame.Edit.Errors.AddObject(v,err);
                     Main.PageControl.ActivePage:=ps;
                     Main.PageControl.OnChange(Main.PageControl);
                     ps.Frame.Edit.Repaint;
                  end
               end;

         end;
         skip:
         inc(i);
   until i>Count-1;
end;

function TDebugger.isFileOpen(v:string):TPageSheet;
var
   i:integer;
begin
   result:=nil;
   if v='' then exit;
   for i:=0 to Main.PageControl.PageCount-1 do begin
       if comparetext(TPageSheet(Main.PageControl.Pages[i]).FileName,v)=0 then begin
          result:=TPageSheet(Main.PageControl.Pages[i]);
          Main.PageControl.ActivePage:=result;
       end
   end
end;

procedure TDebugger.Reset;
var
   i:integer;
begin
    for i:=0 to Main.PageControl.PageCount-1 do
        TPageSheet(Main.PageControl.Pages[i]).Frame.Edit.Reset;
    ffiles.Clear;
end;

end.
