unit MainUnit;

{$SetPEFlags $0100}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,CommCtrl,
  Dialogs, Menus, PageSheet, StdCtrls,ComCtrls, ToolWin, ImgList, CompilerUnit, SynEdit,
  DebuggerUnit, SynEditTypes, ShellApi, XPMan, SettingsUnit, ExtCtrls, ScannerUnit,
  TypesUnit;

const
   wm_newpage=wm_app+1000;
   wm_freepage=wm_app+1001;
   wm_newapp=wm_app+1002;

type
  TMain = class(TForm)
    MainMenu: TMainMenu;
    menuFile: TMenuItem;
    menuNew: TMenuItem;
    menuOpen: TMenuItem;
    menuSave: TMenuItem;
    menuSaveAs: TMenuItem;
    N1: TMenuItem;
    menuExit: TMenuItem;
    StatusBar: TStatusBar;
    ToolBar: TToolBar;
    PageControl: TPageControl;
    s1: TToolButton;
    tbNew: TToolButton;
    tbOpen: TToolButton;
    tbSave: TToolButton;
    s2: TToolButton;
    tbSaveAll: TToolButton;
    s3: TToolButton;
    tbSettings: TToolButton;
    s4: TToolButton;
    tbHelp: TToolButton;
    ImageList: TImageList;
    s5: TToolButton;
    tbCompileRun: TToolButton;
    tbReset: TToolButton;
    PopupMenuPageControl: TPopupMenu;
    menuClosePage: TMenuItem;
    menusearch: TMenuItem;
    menuFind: TMenuItem;
    menureplace: TMenuItem;
    N2: TMenuItem;
    menuGotoLine: TMenuItem;
    menuAction: TMenuItem;
    menuCompile: TMenuItem;
    menuRun: TMenuItem;
    menuCompileRun: TMenuItem;
    N3: TMenuItem;
    menuProgramReset: TMenuItem;
    menuAbout: TMenuItem;
    menuHelp: TMenuItem;
    N4: TMenuItem;
    menuWebPage: TMenuItem;
    N5: TMenuItem;
    menuSoftware: TMenuItem;
    ReplaceDialog: TReplaceDialog;
    FindDialog: TFindDialog;
    XPManifest: TXPManifest;
    N6: TMenuItem;
    menuCloseAllPages: TMenuItem;
    PopupMenuCompile: TPopupMenu;
    menuSwitch: TMenuItem;
    menuView: TMenuItem;
    Settings1: TMenuItem;
    N7: TMenuItem;
    menuToolBar: TMenuItem;
    menuStatusBar: TMenuItem;
    menuCodeExplorer: TMenuItem;
    N8: TMenuItem;
    menuPlugins: TMenuItem;
    N9: TMenuItem;
    TreeView: TTreeView;
    Splitter: TSplitter;
    ImageListTree: TImageList;
    N10: TMenuItem;
    menuLanguage: TMenuItem;
    N11: TMenuItem;
    menuResultWindow: TMenuItem;
    N12: TMenuItem;
    menuPrint: TMenuItem;
    menuExport: TMenuItem;
    menuHTML: TMenuItem;
    menuRTF: TMenuItem;
    N13: TMenuItem;
    procedure tbNewClick(Sender: TObject);
    procedure menuNewClick(Sender: TObject);
    procedure tbOpenClick(Sender: TObject);
    procedure menuOpenClick(Sender: TObject);
    procedure PageControlChange(Sender: TObject);
    procedure tbSaveClick(Sender: TObject);
    procedure menuSaveClick(Sender: TObject);
    procedure menuSaveAsClick(Sender: TObject);
    procedure tbSaveAllClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure tbCompileRunClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure tbResetClick(Sender: TObject);
    procedure FormShortCut(var Msg: TWMKey; var Handled: Boolean);
    procedure menuClosePageClick(Sender: TObject);
    procedure menuSoftwareClick(Sender: TObject);
    procedure menuFindClick(Sender: TObject);
    procedure FindDialogShow(Sender: TObject);
    procedure FindDialogFind(Sender: TObject);
    procedure FindDialogClose(Sender: TObject);
    procedure ReplaceDialogShow(Sender: TObject);
    procedure ReplaceDialogFind(Sender: TObject);
    procedure ReplaceDialogReplace(Sender: TObject);
    procedure ReplaceDialogClose(Sender: TObject);
    procedure menureplaceClick(Sender: TObject);
    procedure menuGotoLineClick(Sender: TObject);
    procedure menuCompileClick(Sender: TObject);
    procedure menuRunClick(Sender: TObject);
    procedure menuCompileRunClick(Sender: TObject);
    procedure menuProgramResetClick(Sender: TObject);
    procedure tbHelpClick(Sender: TObject);
    procedure menuWebPageClick(Sender: TObject);
    procedure tbSettingsClick(Sender: TObject);
    procedure menuFileClick(Sender: TObject);
    procedure menusearchClick(Sender: TObject);
    procedure menuActionClick(Sender: TObject);
    procedure menuExitClick(Sender: TObject);
    procedure menuCloseAllPagesClick(Sender: TObject);
    procedure PopupMenuPageControlPopup(Sender: TObject);
    procedure menuSwitchClick(Sender: TObject);
    procedure menuHelpClick(Sender: TObject);
    procedure Settings1Click(Sender: TObject);
    procedure menuCodeExplorerClick(Sender: TObject);
    procedure menuToolBarClick(Sender: TObject);
    procedure menuStatusBarClick(Sender: TObject);
    procedure menuViewClick(Sender: TObject);
    procedure menuPluginsClick(Sender: TObject);
    procedure TreeViewClick(Sender: TObject);
    procedure menuLanguageClick(Sender: TObject);
    procedure menuResultWindowClick(Sender: TObject);
    procedure menuPrintClick(Sender: TObject);
    procedure menuHTMLClick(Sender: TObject);
    procedure menuRTFClick(Sender: TObject);
  protected
    procedure WndProc(var m :TMessage);override;
  private
    { Private declarations }
    procedure CompilerError(Sender:TObject);
    procedure CompilerRun(Sender:TObject);
    procedure CompilerAfterRun(Sender:TObject);
    procedure CompilerTerminate(Sender:TObject);
    procedure CompilerCompile(Sender:TObject);
  public
    { Public declarations }
    procedure UpdateToolBar;
    procedure CheckFiles;
    function newPage(v:string=''):TPageSheet;
    procedure NewApplication;
    procedure SearchCompiler;
    procedure Load(v:string);
    procedure LoadPlugins;
    procedure LoadPlugin(v:string);
    procedure unLoadPlugins;
    function FindPage(v:string):TPageSheet;
  end;

  function newEditor(v:PChar):TPageSheet;stdcall;
  procedure freePage(v:Pointer);
  procedure newApp(v:PChar);

  function SetDllDirectory(lpPathName:PWideChar): Bool; stdcall; external 'kernel32.dll' name 'SetDllDirectoryW';

var
  Main: TMain;
  wDir:string;
  ActivePage:TPageSheet;
  Compiler:TCompiler;
  Debugger:TDebugger;
  Launcher:TLauncher;
  CodeExplorer:TTreeView;
  Scanner:TScanner;
  BridgeFile:string;
  ActiveProject:TProject;
  ActiveObject:TObject;
  ActiveLang:TLang;
  SearchOptions, ReplaceOptions:TSynSearchOptions;

implementation

{$R *.dfm}

uses ResultUnit, HelperUnit, GoLineUnit, AboutUnit, FrameEditUnit,
  PluginUnits, QuerySwitchUnit, LanguagesUnit, PrintUnit;

function newEditor(v:PChar):TPageSheet;
begin
    result:=Main.newPage(StrPas(v));
end;

procedure freePage(v:Pointer);
begin
    if v<>nil then
       TPageSheet(v).Free;
end;

procedure newApp(v:PChar);
begin
    Main.newApplication;
    ActivePage.FileName:=StrPas(v);
end;

procedure SaveObjs;
var
   L:TStrings;
begin
    L:=TStringList.Create;
    L.Add(inttostr( Main.Handle));
    L.Add(inttostr( Main.MainMenu.Handle));
    L.Add(inttostr( Main.ToolBar.Handle));
    L.Add(inttostr( Main.ImageList.Handle));
    L.Add(inttostr( integer(@newEditor)));
    L.Add(inttostr( integer(@freePage)));
    L.SaveToFile('Plugin_Data.plg');
end;

procedure TMain.WndProc(var m:TMessage);
begin
    if m.Msg=wm_app+1000 then begin
    end ;
    inherited
end;

procedure TMain.UpdateToolBar;
begin
   tbSave.Enabled:=ActivePage<>nil;
   tbSaveAll.Enabled:=PageControl.PageCount>1;
   menuSave.Enabled:=(ActivePage<>nil) and FileExists(ActivePage.FileName);
   tbCompileRun.Enabled:=(Compiler<>nil) and (ActivePage<>nil) and (Compiler.isRunning=false);
   tbReset.Enabled:=(Compiler<>nil) and (Compiler.isRunning)
end;

{procedure TMain.LoadPlugins;
var
   i:integer;
   m:hmodule;
   Succes,Error:string;
   s:string;
begin
   SaveObjs;
    Plugins.ListBox.Clear;

    FindFiles(Plugins.ListBox.Items,wDir+'Plugins','*.dll');
    s:='';
    for i:=0 to Plugins.ListBox.Items.Count-1 do begin
        try
           Dll:=LoadLibrary(PChar(Plugins.ListBox.Items[i]));
           Plugins.ListBox.Items.Objects[i]:=TObject(Dll);
        except
            messageDlg('Error when load plugin(s).',mtError,[mbok],0)
        end;
        s:=s+format(' "%s"',[Plugins.ListBox.Items[i]]);
    end;

end;}

procedure TMain.LoadPlugins;
var
   i:integer;
   s:string;
begin
   SaveObjs;
    Plugins.ListBox.Clear;

    FindFiles(Plugins.ListBox.Items,wDir+'Plugins','*.fbp');
    s:='';
    for i:=0 to Plugins.ListBox.Items.Count-1 do begin
        try
            Compiler.Params:=Plugins.ListBox.Items[i];
            Compiler.Switch:='-dll -b';
            Compiler.Compile;
            if FileExists(Compiler.Outfile) then begin
                Dll:=LoadLibrary(PChar(Compiler.Outfile));
                Plugins.ListBox.Items.Objects[i]:=TObject(Dll);
            end
        except
            messageDlg('Error when load plugin(s).',mtError,[mbok],0)
        end;
        s:=s+format(' "%s"',[Plugins.ListBox.Items[i]]);
    end;
    if s<>'' then;
end;

procedure TMain.LoadPlugin(v:string);
var
   m:hmodule;
   x:integer;
begin
    if FileExists(v) then begin
       m:=LoadLibrary(PChar(v));
       if m>0 then begin
          x:=Plugins.ListBox.Items.IndexOf(v);
          if x>-1 then
             Plugins.ListBox.Items.Objects[x]:=TObject(m);
       end else messageDlg(format('Loading of %s plugin failed. Error was %d.',[v,GetLastError]),mtError,[mbok],0);
    end

end;


procedure TMain.unLoadPlugins;
var
   i:integer;
   m:hmodule;
begin
    for i:=0 to Plugins.ListBox.Items.Count-1 do begin
        m:=hmodule(Pointer(Plugins.ListBox.Items.Objects[i]));
        if m>0 then FreeLibrary(m);
    end
end;

function TMain.FindPage(v:string):TPageSheet;
var
   i:integer;
   Ps:TPageSheet;
begin
    result:=nil;
    if v='' then exit;
    for i:=0 to PageControl.PageCount-1 do begin
        Ps:=TPageSheet(PageControl.Pages[i]);
        if Ps<>nil then
           if CompareText(Ps.FileName,v)=0 then begin
              result:=Ps;
              break
           end
    end
end;

procedure TMain.CheckFiles;
var
   i:integer;
begin
   for i:=PageControl.PageCount-1 downto 0 do
       TPageSheet(PageControl.Pages[i]).Dispose
end;

procedure TMain.NewApplication;
begin
    CheckFiles;
    PageID:=0;
    newPage;
end;

procedure TMain.SearchCompiler;
var
   c:string;
begin
    if DirectoryExists(GetSpecialFolderPath(CSIDL_PROGRAM_FILESX86)) then
       c:=GetSpecialFolderPath(CSIDL_PROGRAM_FILESX86);
    if c='' then
       if DirectoryExists(GetSpecialFolderPath(CSIDL_PROGRAM_FILES)) then
          c:=GetSpecialFolderPath(CSIDL_PROGRAM_FILES);
    c:=c+'\freebasic\fbc.exe';
    if FileExists(c) then
       Compiler.FileName:=c
    else
       if messageDlg('The compiler are not set.'#10'Do you want to set it now?',mtConfirmation,[mbyes,mbno],0)=mryes then
          with TOpenDialog.Create(nil) do begin
               Filter:='Executable file (*.exe)|*.exe';
               FileName:='fbc.exe';
               if Execute then
                  Compiler.FileName:=FileName;
               free;
          end;
end;

procedure TMain.CompilerError(Sender:TObject);
begin
    Results.Edit.Lines.Assign(Compiler.Outputs);
    Caption:=format('Shrimp ERROR: %s',[Compiler.Params]);
    tbCompileRun.Enabled:=true;
    tbReset.Enabled:=false;
    Results.Visible:=true;
    Debugger.Text:=Results.Edit.Text;
    Debugger.Scan;
end;

procedure TMain.CompilerRun(Sender:TObject);
var
  i:integer;
begin
    Caption:=format('Shrimp RUN: %s',[Compiler.Outfile]);
    tbCompileRun.Enabled:=false;
    tbReset.Enabled:=true;
    if Launcher.Minimize then Main.WindowState:=wsMinimized;
    if Launcher.Disable then begin
       for i:=0 to ToolBar.ButtonCount-1 do
           if (ToolBar.Buttons[i]<>tbCompileRun) and (ToolBar.Buttons[i]<>tbReset) then
               ToolBar.Buttons[i].Enabled:=false;
       PageControl.Enabled:=false;
       for i:=0 to MainMenu.Items.Count-1 do
           MainMenu.Items[i].Enabled:=false;
    end
end;

procedure TMain.CompilerTerminate(Sender:TObject);
var
   i:integer;
begin
    if Compiler.Outputs.Count>0 then
       Results.Edit.Lines.Assign(Compiler.Outputs);
    Caption:='Shrimp';
    tbCompileRun.Enabled:=true;
    tbReset.Enabled:=false;
    if Launcher.Minimize then Main.WindowState:=wsNormal;
    if Launcher.Disable then begin
       for i:=0 to ToolBar.ButtonCount-1 do
           ToolBar.Buttons[i].Enabled:=true;
       PageControl.Enabled:=true;
       for i:=0 to MainMenu.Items.Count-1 do
           MainMenu.Items[i].Enabled:=true;
    end
end;

procedure TMain.CompilerAfterRun(Sender:TObject);
begin
    Caption:='Shrimp';
    tbCompileRun.Enabled:=true;
    tbReset.Enabled:=false;
end;

procedure TMain.CompilerCompile(Sender:TObject);
begin
    Caption:=format('Shrimp COMPILE: %s',[Compiler.Params]);
end;

function TMain.newPage(v:string=''):TPageSheet;
begin
    result:=TPageSheet.Create(PageControl);
    oc.AssignTo(result.Frame.Edit);
    result.FileName:=v;
    result.PageControl:=PageControl;
    PageControl.ActivePage:=result;
    result.Frame.Edit.SetFocus;
    result.Scanner.FileName:=v;
    result.Tree:=TreeView;
    {if FileExists(ideDir+'FreeBasic.ini') then
       result.Frame.FreeBasic.LoadHighlighter(ideDir+'FreeBasic.ini');}
    StatusBar.Panels[0].Text:='';
    StatusBar.Panels[1].Text:='';
    StatusBar.Panels[2].Text:='';
    ActivePage:=result;
    UpdateToolBar;
end;

procedure TMain.tbNewClick(Sender: TObject);
begin
    newPage
end;

procedure TMain.menuNewClick(Sender: TObject);
begin
   tbNew.Click
end;

procedure TMain.tbOpenClick(Sender: TObject);
var
   i:integer;
begin
    with TOpenDialog.Create(nil) do begin
         Filter:='FreeBasic files (*.bas,*.bi)|*.bas;*.bi|FreeBasic Plugin file (*.fbp)|*.fbp|FreeBasic pack file (*.fpk)|*.fpk|Text file (*.txt)|*.txt|All files (*.*)|*.*';
         Options:=Options+[ofAllowMultiSelect];
         if Execute then
            for i:=0 to Files.Count-1 do
                Load(Files[i]);
         Free
    end; UpdateToolBar;
end;

procedure TMain.menuOpenClick(Sender: TObject);
begin
   tbOpen.Click
end;

procedure TMain.PageControlChange(Sender: TObject);
var
   c:TSynStatusChanges;
begin
   ActivePage:=TPageSheet(PageControl.ActivePage);
   UpdateToolBar;
   if ActivePage=nil then exit;
   if ActivePage.Tree<>nil then ActivePage.Tree.Items.Clear;
   ActivePage.Scanner.Edit:=ActivePage.Frame.Edit;
   ActivePage.Tree:=TreeView;
   ActivePage.Frame.Edit.OnStatusChange(ActivePage.Frame.Edit,c);
end;

procedure TMain.tbSaveClick(Sender: TObject);
begin
    if ActivePage<>nil then ActivePage.Save; UpdateToolBar;
end;

procedure TMain.menuSaveClick(Sender: TObject);
begin
    tbSave.Click
end;

procedure TMain.menuSaveAsClick(Sender: TObject);
begin
    if ActivePage<>nil then ActivePage.SaveAs; UpdateToolBar;
end;

procedure TMain.tbSaveAllClick(Sender: TObject);
var
   i:integer;
begin
    for i:=0 to PageControl.PageCount-1 do begin
        if FileExists(TPageSheet(PageControl.Pages[i]).FileName) then
           TPageSheet(PageControl.Pages[i]).Save
        else
           TPageSheet(PageControl.Pages[i]).SaveAs;
        end ;
    UpdateToolBar;
end;

procedure TMain.Load(v:string);
begin
   newPage(v);
   ListDLLExports(v,Results.Edit.Lines);
end;

procedure TMain.FormShow(Sender: TObject);
var
   i:integer;
   
begin
   SaveObjs;
   Launcher.Load;
   try
      if Launcher.Plugins then LoadPlugins;
   except end;
   oc.Gutter.ShowLineNumbers:=Launcher.LineNumbers;
   oc.Font.Name:=Launcher.FontName;
   oc.Font.Size:=Launcher.FontSize;
   if ParamCount>1 then begin
      for i:=1 to ParamCount do
         Load(ParamStr(i))
   end else
      NewApplication;
   UpdateToolBar;
       Results.integrate(Launcher.IntegrateIn);
       Results.Visible:=ResultVisible;
end;

procedure TMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    if IsWindowVisible(FindDialog.Handle) then FindDialog.CloseDialog;
    if IsWindowVisible(ReplaceDialog.Handle) then ReplaceDialog.CloseDialog;
    CheckFiles;
    if Compiler.isRunning then Compiler.Reset;
    Launcher.Save;
end;

procedure TMain.tbCompileRunClick(Sender: TObject);
var
  s,rfl:string;
  L:TStrings;
begin
   Debugger.Reset;
   s:=ActivePage.FileName;
   if s='' then
      s:=ActivePage.Caption;
   if not ActivePage.Saved then
      case messageDlg(format('The %s file was modified. Save?',[s]),mtConfirmation,[mbyes,mbno],0) of
           mryes:tbSave.Click;
      end;
   if FileExists(Launcher.Icon) then begin
      rfl:=changeFileExt(ActivePage.FileName,'.rc');
      L:=TStringList.Create;
      L.Add(Format('1 ICON "%s"',[Launcher.Icon]));
      L.SaveToFile(rfl);
      L.Free
   end;  
   Compiler.Params:=ActivePage.FileName;
   if Compiler.Switch<>'' then
      Compiler.Switch:=Compiler.Switch+' '+rfl
   else
      Compiler.Switch:=rfl;
   Compiler.CompileRun;
end;

procedure TMain.FormCreate(Sender: TObject);
begin
    SearchCompiler;
    Compiler.Main:=Handle;
    Compiler.onError:=CompilerError;
    Compiler.OnRedirect:=CompilerCompile;
    Compiler.OnRun:=CompilerRun;
    Compiler.OnTerminate:=CompilerTerminate;
    Compiler.OnAfterRun:=CompilerAfterRun;
end;

procedure TMain.tbResetClick(Sender: TObject);
begin
    Compiler.Reset
end;

procedure TMain.FormShortCut(var Msg: TWMKey; var Handled: Boolean);
begin
    if msg.CharCode=vk_f2 then begin
       ActivePage.Frame.FreeBasic.SaveHighlighter(wDir+'FreeBasic.ini');
       messageDlg('Done.',mtInformation,[mbok],0);
       Handled:=true;
    end ;
    if msg.CharCode=vk_f3 then begin
       if Launcher.Plugins then begin
          if DirectoryExists(wDir+'plugins') then begin
             Plugins.ListBox.Clear;
             FindFiles(Plugins.ListBox.Items,wDir+'Plugins','*.dll');
             Plugins.Show
          end
       end;
       Handled:=true;
    end
end;

procedure TMain.menuClosePageClick(Sender: TObject);
begin
    ActivePage.Dispose;
    PageControlChange(PageControl);
    if ActivePage=nil then begin
       PageID:=0;
       TreeView.Items.Clear;
    end   
end;

procedure TMain.menuSoftwareClick(Sender: TObject);
begin
   About.showmodal;
end;

procedure TMain.menuFindClick(Sender: TObject);
begin
    SearchOptions:=[ssoEntireScope];
    if frWholeWord in FindDialog.Options then SearchOptions:=SearchOptions+[ssoWholeWord] else SearchOptions:=SearchOptions-[ssoWholeWord];
    if frMatchCase in FindDialog.Options then SearchOptions:=SearchOptions+[ssoMatchCase] else SearchOptions:=SearchOptions-[ssoMatchCase];
    if frDown in FindDialog.Options then SearchOptions:=SearchOptions-[ssoBackwards] else SearchOptions:=SearchOptions+[ssoBackwards];
    FindDialog.Execute;
end;

procedure TMain.FindDialogShow(Sender: TObject);
begin
         if ssoWholeWord in SearchOptions then
            FindDialog.Options:=FindDialog.Options+[frWholeWord]
         else
            FindDialog.Options:=FindDialog.Options-[frWholeWord];
         if ssoMatchCase in SearchOptions then
            FindDialog.Options:=FindDialog.Options+[frMatchCase]
         else
            FindDialog.Options:=FindDialog.Options-[frMatchCase];
         if not (ssoBackwards in SearchOptions) then
            FindDialog.Options:=FindDialog.Options+[frDown]
         else
            FindDialog.Options:=FindDialog.Options-[frDown];
end;

procedure TMain.FindDialogFind(Sender: TObject);
begin
    ActivePage.Frame.Edit.SearchReplace(FindDialog.FindText,'',SearchOptions)
end;

procedure TMain.FindDialogClose(Sender: TObject);
begin
   FindDialog.CloseDialog
end;

procedure TMain.ReplaceDialogShow(Sender: TObject);
begin
    if ssoWholeWord in ReplaceOptions then
            ReplaceDialog.Options:=ReplaceDialog.Options+[frWholeWord]
         else
            ReplaceDialog.Options:=ReplaceDialog.Options-[frWholeWord];
         if ssoMatchCase in ReplaceOptions then
            ReplaceDialog.Options:=ReplaceDialog.Options+[frMatchCase]
         else
            ReplaceDialog.Options:=ReplaceDialog.Options-[frMatchCase];
         if not (ssoBackwards in ReplaceOptions) then
            ReplaceDialog.Options:=ReplaceDialog.Options+[frDown]
         else
            ReplaceDialog.Options:=ReplaceDialog.Options-[frDown];
end;

procedure TMain.ReplaceDialogFind(Sender: TObject);
begin
    ReplaceOptions:=ReplaceOptions-[ssoReplaceAll];
    ActivePage.Frame.Edit.SearchReplace(ReplaceDialog.FindText,'',ReplaceOptions)
end;

procedure TMain.ReplaceDialogReplace(Sender: TObject);
begin
   if frReplaceAll in ReplaceDialog.Options then
      ReplaceOptions:=ReplaceOptions+[ssoReplaceAll]
   else
      ReplaceOptions:=ReplaceOptions-[ssoReplaceAll];
   if frReplace in ReplaceDialog.Options then
      ReplaceOptions:=ReplaceOptions+[ssoReplace]
   else
      ReplaceOptions:=ReplaceOptions-[ssoReplace];
   ActivePage.Frame.Edit.SearchReplace(ReplaceDialog.FindText,ReplaceDialog.ReplaceText,ReplaceOptions)
end;

procedure TMain.ReplaceDialogClose(Sender: TObject);
begin
    ReplaceDialog.CloseDialog;
end;

procedure TMain.menureplaceClick(Sender: TObject);
begin
   ReplaceOptions:=[ssoEntireScope];
    if frWholeWord in ReplaceDialog.Options then ReplaceOptions:=ReplaceOptions+[ssoWholeWord] else ReplaceOptions:=ReplaceOptions-[ssoWholeWord];
    if frMatchCase in ReplaceDialog.Options then ReplaceOptions:=ReplaceOptions+[ssoMatchCase] else ReplaceOptions:=ReplaceOptions-[ssoMatchCase];
    if frDown in ReplaceDialog.Options then ReplaceOptions:=ReplaceOptions-[ssoBackwards] else ReplaceOptions:=ReplaceOptions+[ssoBackwards];
    ReplaceDialog.Execute;
end;

procedure TMain.menuGotoLineClick(Sender: TObject);
begin
    Goline.Show
end;

procedure TMain.menuCompileClick(Sender: TObject);
var
  s:string;
begin
   Debugger.Reset;
   s:=ActivePage.FileName;
   if s='' then
      s:=ActivePage.Caption;
   if not ActivePage.Saved then
      case messageDlg(format('The %s file was modified. Save?',[s]),mtConfirmation,[mbyes,mbno],0) of
           mryes:tbSave.Click;
      end;
    Compiler.Params:=ActivePage.FileName;
    Compiler.Compile;
end;

procedure TMain.menuRunClick(Sender: TObject);
begin
    Compiler.Execute()
end;

procedure TMain.menuCompileRunClick(Sender: TObject);
begin
    tbCompileRun.Click
end;

procedure TMain.menuProgramResetClick(Sender: TObject);
begin
    Compiler.Reset
end;

procedure TMain.tbHelpClick(Sender: TObject);
begin
    if FileExists(wDir+'FreeBasic.chm') then
       ShellExecute(0,'open',PChar(wDir+'FreeBasic.chm'),'','',sw_show)
    else
       messageDlg('Can''t run help file. Not found.',mtINFORMATION,[mbok],0);
end;

procedure TMain.menuWebPageClick(Sender: TObject);
begin
    ShellExecute(0,'open',PChar('http://rqwork.de'),'','',sw_show);
end;

procedure TMain.tbSettingsClick(Sender: TObject);
begin
    if Settings.ShowModal=mrok then begin
    end;
end;

procedure TMain.menuFileClick(Sender: TObject);
begin
    menuSaveAs.Enabled:=ActivePage<>nil;
    menuSave.Enabled:=(ActivePage<>nil) and FileExists(ActivePage.FileName);
    menuPrint.Enabled:=(ActivePage<>nil) and (ActivePage.Frame.Edit.Lines.Count>0);
    menuExport.Enabled:=menuPrint.Enabled;
end;

procedure TMain.menusearchClick(Sender: TObject);
begin
    menuFind.Enabled:=(ActivePage<>nil) and (ActivePage.Frame.Edit.Text<>'');
    menuReplace.Enabled:=menuFind.Enabled;
    menuGoToLine.Enabled:=menuFind.Enabled;
end;

procedure TMain.menuActionClick(Sender: TObject);
begin
    menuCompile.Enabled:=(ActivePage<>nil) and FileExists(Compiler.Params);
    menuRun.Enabled:=(Compiler<>nil) and FileExists(Compiler.Outfile);
    menuCompileRun.Enabled:=menuCompile.Enabled;
    menuProgramReset.Enabled:=(Compiler<>nil) and Compiler.isRunning;
end;

procedure TMain.menuExitClick(Sender: TObject);
begin
   try
     Close;
   except ExitProcess(0); end;
end;

procedure TMain.menuCloseAllPagesClick(Sender: TObject);
var
   i:integer;
begin
    for i:=PageControl.PageCount-1 downto 0 do
        TPageSheet(PageControl.Pages[i]).Dispose;
    PageID:=0    
end;

procedure TMain.PopupMenuPageControlPopup(Sender: TObject);
begin
    menuClosePage.Enabled:=ActivePage<>nil;
    menuCloseAllPages.Enabled:=PageControl.PageCount>1;
end;

procedure TMain.menuSwitchClick(Sender: TObject);
var
   s:string;
begin
    {s:='-s console';
    if InputQuery('Switch','Type your switch, for ex. "-dll":',s) then
       Compiler.Switch:=s;}
    SwitchQuery.cbxKeep.Checked:=Launcher.KeepSwitch;
    if SwitchQuery.cbxKeep.Checked then
       s:=Compiler.Switch
    else
       s:='-s console';
    SwitchQuery.EditSwitch.Text:=s;
    if SwitchQuery.ShowModal=mrok then begin
       Compiler.Switch:=SwitchQuery.EditSwitch.Text;
       Launcher.KeepSwitch:=SwitchQuery.cbxKeep.Checked;
    end;
end;


procedure TMain.menuHelpClick(Sender: TObject);
var
   Pid:Cardinal;
label
    reload;
begin
   reload:
   Pid:=ShellExecute(Handle,'open',PChar(Application.HelpFile),'','',sw_show);
   if Pid<=32 then
      if MessageDlg(format('The %s help file not exists.'#10'Do you want to set now?',[Application.HelpFile]),mtConfirmation,[mbyes,mbno],0) =mryes then
         with TOpenDialog.Create(nil) do begin
              Filter:='Help files (*.chm;*.hlp)|*.hlp;*.chm';
              if Execute then begin
                 Application.HelpFile:=FileName;
                 Launcher.Help:=Application.HelpFile;
                 goto reload;
              end
         end
end;

procedure TMain.Settings1Click(Sender: TObject);
begin
   Settings.ShowModal
end;

procedure TMain.menuCodeExplorerClick(Sender: TObject);
begin
    if CodeExplorer<>nil then begin
    end else MessageDlg('The ''scanner.pas'' module is not present.',mtInformation,[mbok],0)
end;

procedure TMain.menuToolBarClick(Sender: TObject);
begin
    ToolBar.Visible:=TMenuItem(Sender).Checked;
end;

procedure TMain.menuStatusBarClick(Sender: TObject);
begin
    StatusBar.Visible:=TMenuItem(Sender).Checked;
end;

procedure TMain.menuViewClick(Sender: TObject);
begin
    menuToolBar.Checked:=ToolBar.Visible;
    menuStatusBar.Checked:=StatusBar.Visible;
    menuCodeExplorer.Enabled:=CodeExplorer<>nil;
    menuResultWindow.Checked:=Results.Visible;
end;

procedure TMain.menuPluginsClick(Sender: TObject);
begin
    Plugins.ShowModal
end;

procedure TMain.TreeViewClick(Sender: TObject);
var
  F:TField;
begin
    if TreeView.Selected<>nil then
       if TreeView.Selected.Data<>nil then
          if TObject(TreeView.Selected.Data).InheritsFrom(TField) then begin
             F:=TField(TreeView.Selected.Data);
             if ActivePage<>nil then begin
                ActivePage.Frame.Edit.TopLine:=F.Where.Y+1;
                ActivePage.Frame.Edit.CaretY:=F.Where.Y+1;
                ActivePage.Frame.Edit.CaretX:=F.Where.X;
                Windows.SetFocus(ActivePage.Frame.Edit.Handle)
             end
          end
end;

procedure TMain.menuLanguageClick(Sender: TObject);
begin
    LanguagesDlg.show
end;

procedure TMain.menuResultWindowClick(Sender: TObject);
begin
    Results.Visible:=TMenuItem(sender).Checked;
end;

procedure TMain.menuPrintClick(Sender: TObject);
begin
    Prints.showmodal;
end;

procedure TMain.menuHTMLClick(Sender: TObject);
begin
    if ActivePage=nil then exit;
    if ActivePage.Frame.Edit.Lines.Count=0 then
       case messageDlg('The page are empty.',mtInformation,[mbok],0) of
          mrok:exit;
       end;
    ActivePage.Frame.ExporterHTML.ExportAll(activePage.Frame.Edit.Lines);
    with TSaveDialog.Create(nil) do begin
         Filter:='HTML File (*.html)|*.html';
         if Execute then begin
            FileName:=ChangeFileExt(FileName,'.html');
            ActivePage.Frame.ExporterHTML.SaveToFile(FileName);
         end;
         Free
    end;
end;

procedure TMain.menuRTFClick(Sender: TObject);
begin
    if ActivePage=nil then exit;
    if ActivePage.Frame.Edit.Lines.Count=0 then
       case messageDlg('The page are empty.',mtInformation,[mbok],0) of
          mrok:exit;
       end;
    ActivePage.Frame.ExporterRTF.ExportAll(activePage.Frame.Edit.Lines);
    with TSaveDialog.Create(nil) do begin
         Filter:='RTF File (*.rtf)|*.rtf';
         if Execute then begin
            FileName:=ChangeFileExt(FileName,'.rtf');
            ActivePage.Frame.ExporterRTF.SaveToFile(FileName);
         end;
         Free
    end;
end;

initialization
   wDir:=ExtractFilePath(ParamStr(0));
   
   Compiler:=TCompiler.Create;
   Debugger:=TDebugger.Create;
   Scanner:=TScanner.Create;
   Launcher:=TLauncher.Create;
finalization
   Launcher.Free;
   Compiler.Free;
   Debugger.Free;
   Scanner.Free;
end.
