unit PluginUnits;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, HelperUnit, TypInfo;

type
  TPlugins = class(TForm)
    ListBox: TListBox;
    btnClose: TBitBtn;
    btnLoad: TBitBtn;
    btnDispose: TBitBtn;
    btnFile: TBitBtn;
    procedure btnLoadClick(Sender: TObject);
    procedure btnDisposeClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListBoxClick(Sender: TObject);
    procedure btnFileClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Plugins: TPlugins;
  Dll:HMODULE;
  FreeDyn:procedure(sender :Tobject); stdcall;

implementation

{$R *.dfm}

uses MainUnit;

procedure TPlugins.btnLoadClick(Sender: TObject);
var
   i:integer;
   Dll:hmodule;
begin
    i:=ListBox.ItemIndex; Dll:=0;
    if i>-1 then begin
       try
            Compiler.Params:=Plugins.ListBox.Items[i];
            Compiler.Switch:='-dll -b';
            Compiler.Compile;
            if FileExists(Compiler.Outfile) then begin
                Dll:=LoadLibraryEx(PChar(Compiler.Outfile),0,DONT_RESOLVE_DLL_REFERENCES);
                Plugins.ListBox.Items.Objects[i]:=TObject(Dll);
            end
        except
            messageDlg('Error when load plugin(s).',mtError,[mbok],0)
        end;
       if Dll>0 then begin
          messageDlg('Succed.',mtInformation,[mbok],0);
          btnDispose.Enabled:=ListBox.Items.Objects[i]<>nil;
          btnLoad.Enabled:=not btnDispose.Enabled;
       end else
          messageDlg(format('Can''t load plugin. Error %d.',[GetLastError]),mtInformation,[mbok],0);
    end;
end;

procedure TPlugins.btnDisposeClick(Sender: TObject);
var
   i:integer;
begin
    i:=ListBox.ItemIndex;
    if i>-1 then begin
       SendMessage(Main.Handle,wm_app+101,0,0);
       ListBox.Items.Objects[i]:=nil;
       btnLoad.Enabled:=ListBox.Items.Objects[i]=nil;
       btnDispose.Enabled:=not btnLoad.Enabled
    end
end;

procedure TPlugins.btnCloseClick(Sender: TObject);
begin
   Close
end;

procedure TPlugins.FormShow(Sender: TObject);
var
   i:integer;
begin
    for i:=ListBox.Items.Count-1 downto 0 do
        if ListBox.Items.Objects[i]<>nil then
           FreeLibrary(hmodule(ListBox.Items.Objects[i]));
    ListBox.Items.Clear;
    FindFiles(ListBox.Items,wDir+'plugins','*.fbp');
end;

procedure TPlugins.ListBoxClick(Sender: TObject);
var
   i:integer;
begin
   i:=ListBox.ItemIndex;
   if i>-1 then begin
      btnDispose.Enabled:=ListBox.Items.Objects[i]<>nil;
      btnLoad.Enabled:=ListBox.Items.Objects[i]=nil;
   end
end;

procedure TPlugins.btnFileClick(Sender: TObject);
begin
    with TOpenDialog.Create(nil) do begin
         Filter:='FreeBasic plugin File (*.bas,*.bi,*.fbp)|*.bas;*.bi;*.fbp';
         if Execute then
            if ListBox.Items.IndexOf(FileName)=-1 then
               ListBox.Items.Add(FileName);
         Free
    end;
end;

end.
